package io.fabric8.kubernetes.client;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;
public class ConfigBuilder extends io.fabric8.kubernetes.client.ConfigFluentImpl<io.fabric8.kubernetes.client.ConfigBuilder> implements io.fabric8.kubernetes.api.builder.VisitableBuilder<io.fabric8.kubernetes.client.Config,io.fabric8.kubernetes.client.ConfigBuilder>{
  public ConfigBuilder() {
    this(false);
  }
  public ConfigBuilder(java.lang.Boolean validationEnabled) {
    this(new Config(), validationEnabled);
  }
  public ConfigBuilder(io.fabric8.kubernetes.client.ConfigFluent<?> fluent) {
    this(fluent, false);
  }
  public ConfigBuilder(io.fabric8.kubernetes.client.ConfigFluent<?> fluent,java.lang.Boolean validationEnabled) {
    this(fluent, new Config(), validationEnabled);
  }
  public ConfigBuilder(io.fabric8.kubernetes.client.ConfigFluent<?> fluent,io.fabric8.kubernetes.client.Config instance) {
    this(fluent, instance, false);
  }
  public ConfigBuilder(io.fabric8.kubernetes.client.ConfigFluent<?> fluent,io.fabric8.kubernetes.client.Config instance,java.lang.Boolean validationEnabled) {
    this.fluent = fluent; 
    fluent.withMasterUrl(instance.getMasterUrl()); 
    fluent.withApiVersion(instance.getApiVersion()); 
    fluent.withNamespace(instance.getNamespace()); 
    fluent.withTrustCerts(instance.isTrustCerts()); 
    fluent.withDisableHostnameVerification(instance.isDisableHostnameVerification()); 
    fluent.withCaCertFile(instance.getCaCertFile()); 
    fluent.withCaCertData(instance.getCaCertData()); 
    fluent.withClientCertFile(instance.getClientCertFile()); 
    fluent.withClientCertData(instance.getClientCertData()); 
    fluent.withClientKeyFile(instance.getClientKeyFile()); 
    fluent.withClientKeyData(instance.getClientKeyData()); 
    fluent.withClientKeyAlgo(instance.getClientKeyAlgo()); 
    fluent.withClientKeyPassphrase(instance.getClientKeyPassphrase()); 
    fluent.withUsername(instance.getUsername()); 
    fluent.withPassword(instance.getPassword()); 
    fluent.withOauthToken(instance.getOauthToken()); 
    fluent.withWatchReconnectInterval(instance.getWatchReconnectInterval()); 
    fluent.withWatchReconnectLimit(instance.getWatchReconnectLimit()); 
    fluent.withConnectionTimeout(instance.getConnectionTimeout()); 
    fluent.withRequestTimeout(instance.getRequestTimeout()); 
    fluent.withRollingTimeout(instance.getRollingTimeout()); 
    fluent.withScaleTimeout(instance.getScaleTimeout()); 
    fluent.withLoggingInterval(instance.getLoggingInterval()); 
    fluent.withMaxConcurrentRequests(instance.getMaxConcurrentRequests()); 
    fluent.withMaxConcurrentRequestsPerHost(instance.getMaxConcurrentRequestsPerHost()); 
    fluent.withHttp2Disable(instance.isHttp2Disable()); 
    fluent.withHttpProxy(instance.getHttpProxy()); 
    fluent.withHttpsProxy(instance.getHttpsProxy()); 
    fluent.withNoProxy(instance.getNoProxy()); 
    fluent.withErrorMessages(instance.getErrorMessages()); 
    fluent.withUserAgent(instance.getUserAgent()); 
    fluent.withTlsVersions(instance.getTlsVersions()); 
    fluent.withWebsocketTimeout(instance.getWebsocketTimeout()); 
    fluent.withWebsocketPingInterval(instance.getWebsocketPingInterval()); 
    fluent.withProxyUsername(instance.getProxyUsername()); 
    fluent.withProxyPassword(instance.getProxyPassword()); 
    fluent.withTrustStoreFile(instance.getTrustStoreFile()); 
    fluent.withTrustStorePassphrase(instance.getTrustStorePassphrase()); 
    fluent.withKeyStoreFile(instance.getKeyStoreFile()); 
    fluent.withKeyStorePassphrase(instance.getKeyStorePassphrase()); 
    fluent.withImpersonateUsername(instance.getImpersonateUsername()); 
    fluent.withImpersonateGroups(instance.getImpersonateGroups()); 
    fluent.withImpersonateExtras(instance.getImpersonateExtras()); 
    fluent.withOauthTokenProvider(instance.getOauthTokenProvider()); 
    fluent.withCustomHeaders(instance.getCustomHeaders()); 
    fluent.withRequestRetryBackoffLimit(instance.getRequestRetryBackoffLimit()); 
    fluent.withRequestRetryBackoffInterval(instance.getRequestRetryBackoffInterval()); 
    fluent.withUploadConnectionTimeout(instance.getUploadConnectionTimeout()); 
    fluent.withUploadRequestTimeout(instance.getUploadRequestTimeout()); 
    fluent.withContexts(instance.getContexts());

    fluent.withCurrentContext(instance.getCurrentContext());

    fluent.withImpersonateGroup(instance.getImpersonateGroup());

    this.validationEnabled = validationEnabled; 
  }
  public ConfigBuilder(io.fabric8.kubernetes.client.Config instance) {
    this(instance,false);
  }
  public ConfigBuilder(io.fabric8.kubernetes.client.Config instance,java.lang.Boolean validationEnabled) {
    this.fluent = this; 
    this.withMasterUrl(instance.getMasterUrl()); 
    this.withApiVersion(instance.getApiVersion()); 
    this.withNamespace(instance.getNamespace()); 
    this.withTrustCerts(instance.isTrustCerts()); 
    this.withDisableHostnameVerification(instance.isDisableHostnameVerification()); 
    this.withCaCertFile(instance.getCaCertFile()); 
    this.withCaCertData(instance.getCaCertData()); 
    this.withClientCertFile(instance.getClientCertFile()); 
    this.withClientCertData(instance.getClientCertData()); 
    this.withClientKeyFile(instance.getClientKeyFile()); 
    this.withClientKeyData(instance.getClientKeyData()); 
    this.withClientKeyAlgo(instance.getClientKeyAlgo()); 
    this.withClientKeyPassphrase(instance.getClientKeyPassphrase()); 
    this.withUsername(instance.getUsername()); 
    this.withPassword(instance.getPassword()); 
    this.withOauthToken(instance.getOauthToken()); 
    this.withWatchReconnectInterval(instance.getWatchReconnectInterval()); 
    this.withWatchReconnectLimit(instance.getWatchReconnectLimit()); 
    this.withConnectionTimeout(instance.getConnectionTimeout()); 
    this.withRequestTimeout(instance.getRequestTimeout()); 
    this.withRollingTimeout(instance.getRollingTimeout()); 
    this.withScaleTimeout(instance.getScaleTimeout()); 
    this.withLoggingInterval(instance.getLoggingInterval()); 
    this.withMaxConcurrentRequests(instance.getMaxConcurrentRequests()); 
    this.withMaxConcurrentRequestsPerHost(instance.getMaxConcurrentRequestsPerHost()); 
    this.withHttp2Disable(instance.isHttp2Disable()); 
    this.withHttpProxy(instance.getHttpProxy()); 
    this.withHttpsProxy(instance.getHttpsProxy()); 
    this.withNoProxy(instance.getNoProxy()); 
    this.withErrorMessages(instance.getErrorMessages()); 
    this.withUserAgent(instance.getUserAgent()); 
    this.withTlsVersions(instance.getTlsVersions()); 
    this.withWebsocketTimeout(instance.getWebsocketTimeout()); 
    this.withWebsocketPingInterval(instance.getWebsocketPingInterval()); 
    this.withProxyUsername(instance.getProxyUsername()); 
    this.withProxyPassword(instance.getProxyPassword()); 
    this.withTrustStoreFile(instance.getTrustStoreFile()); 
    this.withTrustStorePassphrase(instance.getTrustStorePassphrase()); 
    this.withKeyStoreFile(instance.getKeyStoreFile()); 
    this.withKeyStorePassphrase(instance.getKeyStorePassphrase()); 
    this.withImpersonateUsername(instance.getImpersonateUsername()); 
    this.withImpersonateGroups(instance.getImpersonateGroups()); 
    this.withImpersonateExtras(instance.getImpersonateExtras()); 
    this.withOauthTokenProvider(instance.getOauthTokenProvider()); 
    this.withCustomHeaders(instance.getCustomHeaders()); 
    this.withRequestRetryBackoffLimit(instance.getRequestRetryBackoffLimit()); 
    this.withRequestRetryBackoffInterval(instance.getRequestRetryBackoffInterval()); 
    this.withUploadConnectionTimeout(instance.getUploadConnectionTimeout()); 
    this.withUploadRequestTimeout(instance.getUploadRequestTimeout()); 
    this.withContexts(instance.getContexts());

    this.withCurrentContext(instance.getCurrentContext());

    this.withImpersonateGroup(instance.getImpersonateGroup());

    this.validationEnabled = validationEnabled; 
  }
  io.fabric8.kubernetes.client.ConfigFluent<?> fluent;
  java.lang.Boolean validationEnabled;
  public io.fabric8.kubernetes.client.Config build() {
    Config buildable = new Config(fluent.getMasterUrl(),fluent.getApiVersion(),fluent.getNamespace(),fluent.isTrustCerts(),fluent.isDisableHostnameVerification(),fluent.getCaCertFile(),fluent.getCaCertData(),fluent.getClientCertFile(),fluent.getClientCertData(),fluent.getClientKeyFile(),fluent.getClientKeyData(),fluent.getClientKeyAlgo(),fluent.getClientKeyPassphrase(),fluent.getUsername(),fluent.getPassword(),fluent.getOauthToken(),fluent.getWatchReconnectInterval(),fluent.getWatchReconnectLimit(),fluent.getConnectionTimeout(),fluent.getRequestTimeout(),fluent.getRollingTimeout(),fluent.getScaleTimeout(),fluent.getLoggingInterval(),fluent.getMaxConcurrentRequests(),fluent.getMaxConcurrentRequestsPerHost(),fluent.isHttp2Disable(),fluent.getHttpProxy(),fluent.getHttpsProxy(),fluent.getNoProxy(),fluent.getErrorMessages(),fluent.getUserAgent(),fluent.getTlsVersions(),fluent.getWebsocketTimeout(),fluent.getWebsocketPingInterval(),fluent.getProxyUsername(),fluent.getProxyPassword(),fluent.getTrustStoreFile(),fluent.getTrustStorePassphrase(),fluent.getKeyStoreFile(),fluent.getKeyStorePassphrase(),fluent.getImpersonateUsername(),fluent.getImpersonateGroups(),fluent.getImpersonateExtras(),fluent.getOauthTokenProvider(),fluent.getCustomHeaders(),fluent.getRequestRetryBackoffLimit(),fluent.getRequestRetryBackoffInterval(),fluent.getUploadConnectionTimeout(),fluent.getUploadRequestTimeout());
    buildable.setContexts(fluent.getContexts());
    buildable.setCurrentContext(fluent.getCurrentContext());
    buildable.setImpersonateGroup(fluent.getImpersonateGroup());
    return buildable;
  }
  public boolean equals(java.lang.Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    if (!super.equals(o)) return false;
    ConfigBuilder that = (ConfigBuilder) o;
    if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

    if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
    return true;
  }
  public int hashCode() {
    return java.util.Objects.hash(fluent,  validationEnabled,  super.hashCode());
  }
  
}